<!DOCTYPE html>
<html>
    <head>
        <title>Page one of the calculation quiz</title>
    </head>
    <body>

        <div class="main-container">
            <h2 class="title">Question Placeholder</h2>
            <div class="input-wrapper">
              <input type="text" class="input" data-dom-state="input-1" />
            </div>
            <div class="button-wrapper">
              <button class="button" onclick="changeLabelTo('1')">1</button>
              <button class="button" onclick="changeLabelTo('2')">2</button>
              <button class="button" onclick="changeLabelTo('3')">3</button>
              <button class="button" onclick="changeLabelTo('4')">4</button>
              <button class="button" onclick="changeLabelTo('5')">5</button>
              <button class="button" onclick="changeLabelTo('6')">6</button>
              <button class="button" onclick="changeLabelTo('7')">7</button>
              <button class="button" onclick="changeLabelTo('8')">8</button>
              <button class="button" onclick="changeLabelTo('9')">9</button>
              <button class="button" onclick="changeLabelTo('.')">.</button>
              <button class="button" onclick="changeLabelTo('-')">-</button>
              <button class="button" onclick="changeLabelTo('0')">0</button>
            </div>
            <button class="button-2" onclick=checkInput()>Enter</button>
          </div>
          <div class="builder-canvas"></div>
          
          <style>
            .main-container {
              align-items: center;
              background-color: #000;
              color: #fff;
              display: flex;
              flex-direction: column;
              height: 100vh;
              justify-content: center;
            }
          
            .title {
              font-size: 24px;
              margin-bottom: 20px;
            }
          
            .input-wrapper {
              align-items: center;
              display: flex;
              justify-content: center;
              margin-bottom: 20px;
            }
          
            .input {
              background-color: #333;
              border-radius: 5px;
              border-top-left-radius: 5px;
              color: #fff;
              font-size: 18px;
              height: 40px;
              width: 250px;
              padding: 10px;
            }
          
            .button-wrapper {
              column-gap: 10px;
              display: grid;
              gap: 10px;
              grid-template-columns: repeat(3, 1fr);
              margin-bottom: 20px;
              row-gap: 10px;
            }
          
            .button {
              all: unset;
              background-color: #333;
              border-bottom: none;
              border-color: #fff;
              border-left: none;
              border-radius: 5px;
              border-right: none;
              border-top: none;
              border-top-left-radius: 5px;
              color: #fff;
              font-size: 18px;
              height: 60px;
              width: 80px;
              padding: 10px;
            }
          
            .button-2 {
              all: unset;
              background-color: #0087f0;
              border-bottom: none;
              border-color: #fff;
              border-left: none;
              border-radius: 5px;
              border-right: none;
              border-top: none;
              border-top-left-radius: 5px;
              color: #fff;
              font-size: 24px;
              height: 80px;
              width: 258px;
              padding: 10px;
            }
          
            .builder-canvas {
              display: flex;
              flex-direction: column;
              position: relative;
              min-height: 500px;
            }
          </style>
   


   <script> 

    var num 
    var unit
    var score 
    num = generateRandomNum(-100, 100)
    unit = generateRandomNum(0, (Object.keys(createDict()).length)-1)  // determines randomly which conversion to use
    score = 0

    function generateRandomNum(min,max){
      // generate a random number for conversions
      // from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random?retiredLocale=de (11/11/23)
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min) + min); // The maximum is exclusive and the minimum is inclusive
    }

    function getSols(){
      // solutions for conversions
      var sol1 = (num - 32) * 5/9  // F to C
      var sol2 = num * 1.8 + 32  // C to F
      var sol3 = num - 273.15  // K to C
      var sol4 = num + 273.15  // C to K
      var sol5 = (num - 273.15) * (9/5) +32 // K to F 
      var sol6 = (5/9) * (num - 32) + 273.15  // F to K
      var sol7 = num / 3.6  // km/h to m/s
      var sol8 = num * 3.6  // m/s to km/h
      return [sol1,sol2,sol3,sol4,sol5,sol6,sol7,sol8]
    }

    function createDict(){  
      // create dictionary with questions
      var questionnaire = {  // hätte eigentlich auch einfach eine liste machen können statt nem dict
        "quest1": `Rechne ${num}°F in °C um`,
        "quest2": `Rechne ${num}°C in °F um`,
        "quest3": `Rechne ${num}K in °C um`,
        "quest4": `Rechne ${num}°C in K um`,
        "quest5": `Rechne ${num}K in °F um`, 
        "quest6": `Rechne ${num}°F in K um`,
        "quest7": `Rechne ${num}km/h in m/s um`,
        "quest8": `Rechne ${num}m/s in km/h um`
      }
      return questionnaire
    }
    
    function generateRandomQuest(questionnaire, unit){
      var key = Object.keys(questionnaire)  // get list of all keys
      return questionnaire[key[unit]]  // return random question
    }

    function changeQuestionLabelTo(questionnaire,unit){
      // from https://stackoverflow.com/questions/21813122/changing-content-of-class-using-javascript (12/11/23)
      quest = generateRandomQuest(questionnaire,unit)
      x = document.getElementsByClassName('title')
      for(var i = 0; i < x.length; i++){
        x[i].innerText=quest;    
        }
    }

    function changeLabelTo(number) {
      // select input class and append number to the text label
      document.querySelector('.input').value += number;
    }

    function nextQuest(){
      num = generateRandomNum(-100, 100)
      unit = generateRandomNum(0, (Object.keys(createDict()).length)-1)
      changeQuestionLabelTo(createDict(),unit)
    }

    function clearInput(){
      // to clear input after entering
      document.querySelector('.input').value = '';
    }

   function afterEnter(colour){
      // give feedback to input and go on to next question
      document.querySelector('.input').style.backgroundColor = colour
      setTimeout(function() {
        document.querySelector('.input').style.backgroundColor = "#333";
        nextQuest()
        clearInput()
      }, 1500);
   }

   
    function checkInput(){
      sols = getSols()
      var userInput = document.querySelector('.input').value 
      userInput = Number(userInput)
      var answerToQuest = sols[unit]
      if(userInput === (Math.round((answerToQuest + Number.EPSILON) * 100) / 100)){ 
        score+=1
        afterEnter("green")
        console.log(score)  // müsste man dann auf das label übertragen, wenn man eines machen möchte
      }
      else{
        // bzw. game over
        score = 0
        afterEnter("red")
        alert("Falsch! Dein Score wurde wieder auf 0 gesetzt.")  // kann man auch weglassen bzw. sollte hier das spiel beendet werden 
      }
    }
    
    changeQuestionLabelTo(createDict(),unit)

  </script>

</body>

</html>